#include <gtk/gtk.h>

static void draw (cairo_t *cr);

static gboolean
handle_expose (GtkWidget *widget, GdkEventExpose *event, gpointer data) {
    cairo_t *cr = gdk_cairo_create (widget->window);
    draw (cr);
    cairo_destroy (cr);
    return FALSE;
}
int main (int argc, char **argv) {
    GtkWidget *window, *drawing_area;
    gtk_init (&argc, &argv);
    window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
    gtk_window_set_default_size (GTK_WINDOW (window), WIDTH, HEIGHT);
    drawing_area = gtk_drawing_area_new ();
    gtk_container_add (GTK_CONTAINER (window), drawing_area);
    g_signal_connect (drawing_area, "expose-event",
		      G_CALLBACK (handle_expose), NULL);
    gtk_widget_show_all (window);
    gtk_main ();
    return 0;
}
